"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@tangential/core");
var moment = require("moment");
var configurable_input_type_1 = require("../configurable-input-type");
var date_time_ival_1 = require("./date-time-ival");
var BROWSER_DATE_TIME_LOCAL_FORMAT = 'YYYY-MM-DDTHH:mm:ss';
var Model = {
    afterMils: null,
    beforeMils: null,
    defaultValue: null,
    defaultToNow: true
};
var DateTimeType = (function (_super) {
    __extends(DateTimeType, _super);
    function DateTimeType(config, key) {
        return _super.call(this, config || {}, key) || this;
    }
    DateTimeType.prototype.getInputTypeKey = function () {
        return DateTimeType.TYPE_NAME;
    };
    Object.defineProperty(DateTimeType.prototype, "uiValue", {
        get: function () {
            return moment(this.defaultValue).format(BROWSER_DATE_TIME_LOCAL_FORMAT);
        },
        set: function (val) {
            this.defaultValue = moment(val, BROWSER_DATE_TIME_LOCAL_FORMAT).valueOf();
        },
        enumerable: true,
        configurable: true
    });
    DateTimeType.prototype.isNumeric = function () {
        return false;
    };
    DateTimeType.prototype.createValue = function (cfg, key) {
        cfg = cfg || {};
        return new date_time_ival_1.DateTimeIval({
            value: cfg.value || this.getDefaultValue(),
            recordedInTimeZone: cfg.recordedInTimeZone || 'GMT'
        }, key || this.$key);
    };
    DateTimeType.prototype.getDefaultValue = function () {
        return this.defaultToNow ? Date.now() : this.defaultValue;
    };
    return DateTimeType;
}(configurable_input_type_1.ConfigurableInputType));
DateTimeType.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_type_1.ConfigurableInputType.$model, Model);
DateTimeType.TYPE_NAME = 'DateTime';
exports.DateTimeType = DateTimeType;
configurable_input_type_1.ConfigurableInputType.register(DateTimeType);

//# sourceMappingURL=date-time-type.js.map
