"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@tangential/core");
//noinspection TypeScriptPreferShortImport
var checkbox_widget_config_1 = require("../widgets/checkbox/checkbox-widget-config");
//noinspection TypeScriptPreferShortImport
var checkbox_widget_template_component_1 = require("../widgets/checkbox/checkbox-widget.template.component");
//noinspection TypeScriptPreferShortImport
var date_time_input_config_1 = require("../widgets/date-time-input/date-time-input-config");
//noinspection TypeScriptPreferShortImport
var date_time_template_component_1 = require("../widgets/date-time-input/date-time-template.component");
//noinspection TypeScriptPreferShortImport
var duration_picker_config_1 = require("../widgets/duration-picker/duration-picker-config");
//noinspection TypeScriptPreferShortImport
var duration_picker_template_component_1 = require("../widgets/duration-picker/duration-picker-template.component");
//noinspection TypeScriptPreferShortImport
var icon_rating_widget_config_1 = require("../widgets/icon-rating-widget/icon-rating-widget-config");
//noinspection TypeScriptPreferShortImport
var icon_rating_widget_template_component_1 = require("../widgets/icon-rating-widget/icon-rating-widget.template.component");
//noinspection TypeScriptPreferShortImport
var number_input_config_1 = require("../widgets/number-input/number-input-config");
//noinspection TypeScriptPreferShortImport
var number_template_component_1 = require("../widgets/number-input/number-template.component");
//noinspection TypeScriptPreferShortImport
var number_slider_config_1 = require("../widgets/number-slider/number-slider-config");
//noinspection TypeScriptPreferShortImport
var number_slider_template_component_1 = require("../widgets/number-slider/number-slider-template.component");
//noinspection TypeScriptPreferShortImport
var number_spinner_config_1 = require("../widgets/number-spinner/number-spinner-config");
//noinspection TypeScriptPreferShortImport
var number_spinner_template_component_1 = require("../widgets/number-spinner/number-spinner-template.component");
//noinspection TypeScriptPreferShortImport
var slide_toggle_widget_config_1 = require("../widgets/slide-toggle/slide-toggle-widget-config");
//noinspection TypeScriptPreferShortImport
var slide_toggle_widget_template_component_1 = require("../widgets/slide-toggle/slide-toggle-widget.template.component");
//noinspection TypeScriptPreferShortImport
var text_input_config_1 = require("../widgets/text-input/text-input-config");
//noinspection TypeScriptPreferShortImport
var text_template_component_1 = require("../widgets/text-input/text-template.component");
var input_view_mode_1 = require("./input-view-mode");
var InputSet = (function () {
    function InputSet(config, view) {
        this.inputCtor = config;
        this.view = view;
    }
    InputSet.prototype.createInputConfig = function (data, key) {
        return new this.inputCtor(data || {}, key);
    };
    return InputSet;
}());
exports.InputSet = InputSet;
var InputRegistry = (function () {
    function InputRegistry() {
        this.inputEntries = {};
        this.registerTypes();
    }
    InputRegistry.prototype.registerTypes = function () {
        this.inputEntries[checkbox_widget_config_1.CheckboxWidgetConfig.INPUT_NAME] = new InputSet(checkbox_widget_config_1.CheckboxWidgetConfig, checkbox_widget_template_component_1.CheckboxWidgetTemplateComponent);
        this.inputEntries[slide_toggle_widget_config_1.SlideToggleConfig.INPUT_NAME] = new InputSet(slide_toggle_widget_config_1.SlideToggleConfig, slide_toggle_widget_template_component_1.SlideToggleWidgetTemplateComponent);
        this.inputEntries[number_input_config_1.NumberInputConfig.INPUT_NAME] = new InputSet(number_input_config_1.NumberInputConfig, number_template_component_1.NumberTemplateComponent);
        this.inputEntries[number_spinner_config_1.NumberSpinnerConfig.INPUT_NAME] = new InputSet(number_spinner_config_1.NumberSpinnerConfig, number_spinner_template_component_1.NumberSpinnerTemplateComponent);
        this.inputEntries[number_slider_config_1.NumberSliderConfig.INPUT_NAME] = new InputSet(number_slider_config_1.NumberSliderConfig, number_slider_template_component_1.NumberSliderTemplateComponent);
        this.inputEntries[text_input_config_1.TextInputConfig.INPUT_NAME] = new InputSet(text_input_config_1.TextInputConfig, text_template_component_1.TextTemplateComponent);
        this.inputEntries[date_time_input_config_1.DateTimeInputConfig.INPUT_NAME] = new InputSet(date_time_input_config_1.DateTimeInputConfig, date_time_template_component_1.DateTimeTemplateComponent);
        this.inputEntries[duration_picker_config_1.DurationPickerConfig.INPUT_NAME] = new InputSet(duration_picker_config_1.DurationPickerConfig, duration_picker_template_component_1.DurationPickerTemplateComponent);
        this.inputEntries[icon_rating_widget_config_1.IconRatingWidgetConfig.INPUT_NAME] = new InputSet(icon_rating_widget_config_1.IconRatingWidgetConfig, icon_rating_widget_template_component_1.IconRatingWidgetTemplateComponent);
    };
    InputRegistry.prototype.allTemplates = function (mode) {
        var _this = this;
        return core_2.ObjectUtil.keys(this.inputEntries).map(function (inputName) {
            return _this.createTemplateForTypeKey(inputName, mode);
        });
    };
    InputRegistry.prototype.getInputSet = function (inputName) {
        return this.inputEntries[inputName];
    };
    InputRegistry.prototype.getComponentCtorFor = function (inputConfig, mode) {
        var result;
        var entry = this.inputEntries[inputConfig._inputName];
        result = entry.view;
        if (!result) {
            throw new Error("Invalid mode '" + mode + "'.");
        }
        return result;
    };
    InputRegistry.prototype.createTemplateForTypeKey = function (inputName, mode) {
        var inputEntrySet = this.getInputSet(inputName);
        var inputConfig = inputEntrySet.createInputConfig();
        return {
            config: inputConfig,
            ival: inputConfig.typeConfig.createValue(),
            mode: mode
        };
    };
    InputRegistry.prototype.createTemplateForType = function (inputConfig, mode, ival) {
        ival = ival || inputConfig.typeConfig.createValue({});
        mode = mode || input_view_mode_1.InputViewModes.EDIT;
        ival.$key = inputConfig.$key;
        return {
            config: inputConfig,
            ival: ival,
            mode: mode
        };
    };
    Object.defineProperty(InputRegistry.prototype, "inputNames", {
        get: function () {
            return Object.keys(this.inputEntries);
        },
        enumerable: true,
        configurable: true
    });
    return InputRegistry;
}());
InputRegistry = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [])
], InputRegistry);
exports.InputRegistry = InputRegistry;

//# sourceMappingURL=input-types-registry.js.map
