"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//noinspection TypeScriptPreferShortImport
var configurable_input_ival_1 = require("../../../data-type/configurable-input-ival");
var input_config_1 = require("../../../input-config");
var input_types_registry_1 = require("../../input-types-registry");
var input_template_directive_1 = require("./input-template.directive");
var InputTemplateContainerComponent = (function () {
    function InputTemplateContainerComponent(_typeRegistry, _componentFactoryResolver, _zone) {
        this._typeRegistry = _typeRegistry;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._zone = _zone;
        this.mode = null;
        this.hideLabel = false;
        this.onlyLabel = false;
        this.change = new core_1.EventEmitter(false);
    }
    InputTemplateContainerComponent.prototype.ngAfterViewInit = function () {
    };
    InputTemplateContainerComponent.prototype.ngOnDestroy = function () {
    };
    InputTemplateContainerComponent.prototype.ngOnChanges = function (changes) {
        if (changes.template && this.template) {
            this.inputConfig = this.template.config;
            this.inputIval = this.template.ival;
            this.mode = this.template.mode;
            this.hideLabel = this.template.hideLabel;
            this.onlyLabel = this.template.onlyLabel;
        }
        if (this.inputConfig) {
            this.loadComponent();
        }
        else {
            console.warn('InputTemplateContainerComponent', 'No input type!', this.inputIval, this.mode);
        }
    };
    InputTemplateContainerComponent.prototype.loadComponent = function () {
        var _this = this;
        this._zone.run(function () {
            var componentCtor = _this._typeRegistry.getComponentCtorFor(_this.inputConfig, _this.mode);
            var componentFactory = _this._componentFactoryResolver.resolveComponentFactory(componentCtor);
            var viewContainerRef = _this.inputItemHost.viewContainerRef;
            viewContainerRef.clear();
            _this._componentRef = viewContainerRef.createComponent(componentFactory);
            _this._componentRef.instance.config = _this.inputConfig;
            _this._componentRef.instance.ival = _this.inputIval;
            _this._componentRef.instance.mode = _this.mode;
            _this._componentRef.instance.hideLabel = _this.hideLabel;
            _this._componentRef.instance.onlyLabel = _this.onlyLabel;
            _this._componentRef.instance.change = _this.change;
            _this._componentRef.changeDetectorRef.detectChanges();
        });
    };
    return InputTemplateContainerComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], InputTemplateContainerComponent.prototype, "template", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", input_config_1.InputConfig)
], InputTemplateContainerComponent.prototype, "inputConfig", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", configurable_input_ival_1.ConfigurableInputIval)
], InputTemplateContainerComponent.prototype, "inputIval", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], InputTemplateContainerComponent.prototype, "mode", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], InputTemplateContainerComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], InputTemplateContainerComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], InputTemplateContainerComponent.prototype, "change", void 0);
__decorate([
    core_1.ViewChild(input_template_directive_1.InputTemplateDirective),
    __metadata("design:type", input_template_directive_1.InputTemplateDirective)
], InputTemplateContainerComponent.prototype, "inputItemHost", void 0);
InputTemplateContainerComponent = __decorate([
    core_1.Component({
        selector: 'tanj-input-template-container',
        template: "\n              <ng-template tanj-input-template-host></ng-template>",
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [input_types_registry_1.InputRegistry, core_1.ComponentFactoryResolver, core_1.NgZone])
], InputTemplateContainerComponent);
exports.InputTemplateContainerComponent = InputTemplateContainerComponent;

//# sourceMappingURL=input-template-container.component.js.map
